/* tslint:disable */
/* eslint-disable */
/**
 * OpenAPI definition
 * No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)
 *
 * The version of the OpenAPI document: v0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


import globalAxios, { AxiosPromise, AxiosInstance, AxiosRequestConfig } from 'axios';
import { Configuration } from '../configuration';
// Some imports not used depending on template conditions
// @ts-ignore
import { DUMMY_BASE_URL, assertParamExists, setApiKeyToObject, setBasicAuthToObject, setBearerAuthToObject, setOAuthToObject, setSearchParams, serializeDataIfNeeded, toPathString, createRequestFunction } from '../common';
// @ts-ignore
import { BASE_PATH, COLLECTION_FORMATS, RequestArgs, BaseAPI, RequiredError } from '../base';
// @ts-ignore
import { EntityModelVehicle } from '../model';
// @ts-ignore
import { PagedModelEntityModelVehicle } from '../model';
// @ts-ignore
import { VehicleRequestBody } from '../model';
/**
 * VehicleEntityControllerApi - axios parameter creator
 * @export
 */
export const VehicleEntityControllerApiAxiosParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * delete-vehicle
         * @param {string} id 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        deleteItemResourceVehicleDelete: async (id: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'id' is not null or undefined
            assertParamExists('deleteItemResourceVehicleDelete', 'id', id)
            const localVarPath = `/vehicles/{id}`
                .replace(`{${"id"}}`, encodeURIComponent(String(id)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'DELETE', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * get-vehicle
         * @param {number} [page] Zero-based page index (0..N)
         * @param {number} [size] The size of the page to be returned
         * @param {Array<string>} [sort] Sorting criteria in the format: property,(asc|desc). Default sort order is ascending. Multiple sort criteria are supported.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getCollectionResourceVehicleGet1: async (page?: number, size?: number, sort?: Array<string>, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/vehicles`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            if (page !== undefined) {
                localVarQueryParameter['page'] = page;
            }

            if (size !== undefined) {
                localVarQueryParameter['size'] = size;
            }

            if (sort) {
                localVarQueryParameter['sort'] = sort;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * get-vehicle
         * @param {string} id 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getItemResourceVehicleGet: async (id: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'id' is not null or undefined
            assertParamExists('getItemResourceVehicleGet', 'id', id)
            const localVarPath = `/vehicles/{id}`
                .replace(`{${"id"}}`, encodeURIComponent(String(id)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * patch-vehicle
         * @param {string} id 
         * @param {VehicleRequestBody} vehicleRequestBody 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        patchItemResourceVehiclePatch: async (id: string, vehicleRequestBody: VehicleRequestBody, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'id' is not null or undefined
            assertParamExists('patchItemResourceVehiclePatch', 'id', id)
            // verify required parameter 'vehicleRequestBody' is not null or undefined
            assertParamExists('patchItemResourceVehiclePatch', 'vehicleRequestBody', vehicleRequestBody)
            const localVarPath = `/vehicles/{id}`
                .replace(`{${"id"}}`, encodeURIComponent(String(id)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'PATCH', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(vehicleRequestBody, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * create-vehicle
         * @param {VehicleRequestBody} vehicleRequestBody 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        postCollectionResourceVehiclePost: async (vehicleRequestBody: VehicleRequestBody, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'vehicleRequestBody' is not null or undefined
            assertParamExists('postCollectionResourceVehiclePost', 'vehicleRequestBody', vehicleRequestBody)
            const localVarPath = `/vehicles`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(vehicleRequestBody, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * update-vehicle
         * @param {string} id 
         * @param {VehicleRequestBody} vehicleRequestBody 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        putItemResourceVehiclePut: async (id: string, vehicleRequestBody: VehicleRequestBody, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'id' is not null or undefined
            assertParamExists('putItemResourceVehiclePut', 'id', id)
            // verify required parameter 'vehicleRequestBody' is not null or undefined
            assertParamExists('putItemResourceVehiclePut', 'vehicleRequestBody', vehicleRequestBody)
            const localVarPath = `/vehicles/{id}`
                .replace(`{${"id"}}`, encodeURIComponent(String(id)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'PUT', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(vehicleRequestBody, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * VehicleEntityControllerApi - functional programming interface
 * @export
 */
export const VehicleEntityControllerApiFp = function(configuration?: Configuration) {
    const localVarAxiosParamCreator = VehicleEntityControllerApiAxiosParamCreator(configuration)
    return {
        /**
         * delete-vehicle
         * @param {string} id 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async deleteItemResourceVehicleDelete(id: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<void>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.deleteItemResourceVehicleDelete(id, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * get-vehicle
         * @param {number} [page] Zero-based page index (0..N)
         * @param {number} [size] The size of the page to be returned
         * @param {Array<string>} [sort] Sorting criteria in the format: property,(asc|desc). Default sort order is ascending. Multiple sort criteria are supported.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async getCollectionResourceVehicleGet1(page?: number, size?: number, sort?: Array<string>, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<PagedModelEntityModelVehicle>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.getCollectionResourceVehicleGet1(page, size, sort, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * get-vehicle
         * @param {string} id 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async getItemResourceVehicleGet(id: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<EntityModelVehicle>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.getItemResourceVehicleGet(id, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * patch-vehicle
         * @param {string} id 
         * @param {VehicleRequestBody} vehicleRequestBody 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async patchItemResourceVehiclePatch(id: string, vehicleRequestBody: VehicleRequestBody, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<EntityModelVehicle>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.patchItemResourceVehiclePatch(id, vehicleRequestBody, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * create-vehicle
         * @param {VehicleRequestBody} vehicleRequestBody 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async postCollectionResourceVehiclePost(vehicleRequestBody: VehicleRequestBody, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<EntityModelVehicle>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.postCollectionResourceVehiclePost(vehicleRequestBody, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * update-vehicle
         * @param {string} id 
         * @param {VehicleRequestBody} vehicleRequestBody 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async putItemResourceVehiclePut(id: string, vehicleRequestBody: VehicleRequestBody, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<EntityModelVehicle>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.putItemResourceVehiclePut(id, vehicleRequestBody, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
    }
};

/**
 * VehicleEntityControllerApi - factory interface
 * @export
 */
export const VehicleEntityControllerApiFactory = function (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) {
    const localVarFp = VehicleEntityControllerApiFp(configuration)
    return {
        /**
         * delete-vehicle
         * @param {string} id 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        deleteItemResourceVehicleDelete(id: string, options?: any): AxiosPromise<void> {
            return localVarFp.deleteItemResourceVehicleDelete(id, options).then((request) => request(axios, basePath));
        },
        /**
         * get-vehicle
         * @param {number} [page] Zero-based page index (0..N)
         * @param {number} [size] The size of the page to be returned
         * @param {Array<string>} [sort] Sorting criteria in the format: property,(asc|desc). Default sort order is ascending. Multiple sort criteria are supported.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getCollectionResourceVehicleGet1(page?: number, size?: number, sort?: Array<string>, options?: any): AxiosPromise<PagedModelEntityModelVehicle> {
            return localVarFp.getCollectionResourceVehicleGet1(page, size, sort, options).then((request) => request(axios, basePath));
        },
        /**
         * get-vehicle
         * @param {string} id 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getItemResourceVehicleGet(id: string, options?: any): AxiosPromise<EntityModelVehicle> {
            return localVarFp.getItemResourceVehicleGet(id, options).then((request) => request(axios, basePath));
        },
        /**
         * patch-vehicle
         * @param {string} id 
         * @param {VehicleRequestBody} vehicleRequestBody 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        patchItemResourceVehiclePatch(id: string, vehicleRequestBody: VehicleRequestBody, options?: any): AxiosPromise<EntityModelVehicle> {
            return localVarFp.patchItemResourceVehiclePatch(id, vehicleRequestBody, options).then((request) => request(axios, basePath));
        },
        /**
         * create-vehicle
         * @param {VehicleRequestBody} vehicleRequestBody 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        postCollectionResourceVehiclePost(vehicleRequestBody: VehicleRequestBody, options?: any): AxiosPromise<EntityModelVehicle> {
            return localVarFp.postCollectionResourceVehiclePost(vehicleRequestBody, options).then((request) => request(axios, basePath));
        },
        /**
         * update-vehicle
         * @param {string} id 
         * @param {VehicleRequestBody} vehicleRequestBody 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        putItemResourceVehiclePut(id: string, vehicleRequestBody: VehicleRequestBody, options?: any): AxiosPromise<EntityModelVehicle> {
            return localVarFp.putItemResourceVehiclePut(id, vehicleRequestBody, options).then((request) => request(axios, basePath));
        },
    };
};

/**
 * VehicleEntityControllerApi - interface
 * @export
 * @interface VehicleEntityControllerApi
 */
export interface VehicleEntityControllerApiInterface {
    /**
     * delete-vehicle
     * @param {string} id 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof VehicleEntityControllerApiInterface
     */
    deleteItemResourceVehicleDelete(id: string, options?: AxiosRequestConfig): AxiosPromise<void>;

    /**
     * get-vehicle
     * @param {number} [page] Zero-based page index (0..N)
     * @param {number} [size] The size of the page to be returned
     * @param {Array<string>} [sort] Sorting criteria in the format: property,(asc|desc). Default sort order is ascending. Multiple sort criteria are supported.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof VehicleEntityControllerApiInterface
     */
    getCollectionResourceVehicleGet1(page?: number, size?: number, sort?: Array<string>, options?: AxiosRequestConfig): AxiosPromise<PagedModelEntityModelVehicle>;

    /**
     * get-vehicle
     * @param {string} id 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof VehicleEntityControllerApiInterface
     */
    getItemResourceVehicleGet(id: string, options?: AxiosRequestConfig): AxiosPromise<EntityModelVehicle>;

    /**
     * patch-vehicle
     * @param {string} id 
     * @param {VehicleRequestBody} vehicleRequestBody 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof VehicleEntityControllerApiInterface
     */
    patchItemResourceVehiclePatch(id: string, vehicleRequestBody: VehicleRequestBody, options?: AxiosRequestConfig): AxiosPromise<EntityModelVehicle>;

    /**
     * create-vehicle
     * @param {VehicleRequestBody} vehicleRequestBody 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof VehicleEntityControllerApiInterface
     */
    postCollectionResourceVehiclePost(vehicleRequestBody: VehicleRequestBody, options?: AxiosRequestConfig): AxiosPromise<EntityModelVehicle>;

    /**
     * update-vehicle
     * @param {string} id 
     * @param {VehicleRequestBody} vehicleRequestBody 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof VehicleEntityControllerApiInterface
     */
    putItemResourceVehiclePut(id: string, vehicleRequestBody: VehicleRequestBody, options?: AxiosRequestConfig): AxiosPromise<EntityModelVehicle>;

}

/**
 * VehicleEntityControllerApi - object-oriented interface
 * @export
 * @class VehicleEntityControllerApi
 * @extends {BaseAPI}
 */
export class VehicleEntityControllerApi extends BaseAPI implements VehicleEntityControllerApiInterface {
    /**
     * delete-vehicle
     * @param {string} id 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof VehicleEntityControllerApi
     */
    public deleteItemResourceVehicleDelete(id: string, options?: AxiosRequestConfig) {
        return VehicleEntityControllerApiFp(this.configuration).deleteItemResourceVehicleDelete(id, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * get-vehicle
     * @param {number} [page] Zero-based page index (0..N)
     * @param {number} [size] The size of the page to be returned
     * @param {Array<string>} [sort] Sorting criteria in the format: property,(asc|desc). Default sort order is ascending. Multiple sort criteria are supported.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof VehicleEntityControllerApi
     */
    public getCollectionResourceVehicleGet1(page?: number, size?: number, sort?: Array<string>, options?: AxiosRequestConfig) {
        return VehicleEntityControllerApiFp(this.configuration).getCollectionResourceVehicleGet1(page, size, sort, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * get-vehicle
     * @param {string} id 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof VehicleEntityControllerApi
     */
    public getItemResourceVehicleGet(id: string, options?: AxiosRequestConfig) {
        return VehicleEntityControllerApiFp(this.configuration).getItemResourceVehicleGet(id, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * patch-vehicle
     * @param {string} id 
     * @param {VehicleRequestBody} vehicleRequestBody 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof VehicleEntityControllerApi
     */
    public patchItemResourceVehiclePatch(id: string, vehicleRequestBody: VehicleRequestBody, options?: AxiosRequestConfig) {
        return VehicleEntityControllerApiFp(this.configuration).patchItemResourceVehiclePatch(id, vehicleRequestBody, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * create-vehicle
     * @param {VehicleRequestBody} vehicleRequestBody 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof VehicleEntityControllerApi
     */
    public postCollectionResourceVehiclePost(vehicleRequestBody: VehicleRequestBody, options?: AxiosRequestConfig) {
        return VehicleEntityControllerApiFp(this.configuration).postCollectionResourceVehiclePost(vehicleRequestBody, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * update-vehicle
     * @param {string} id 
     * @param {VehicleRequestBody} vehicleRequestBody 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof VehicleEntityControllerApi
     */
    public putItemResourceVehiclePut(id: string, vehicleRequestBody: VehicleRequestBody, options?: AxiosRequestConfig) {
        return VehicleEntityControllerApiFp(this.configuration).putItemResourceVehiclePut(id, vehicleRequestBody, options).then((request) => request(this.axios, this.basePath));
    }
}
